/*
** Sella NMS
** $Id: daemon.cxx,v 1.13 2006/01/24 07:08:09 sella Exp $
** Copyright (c) 2001-2005 Digital Genesis Software, LLC. All Rights Reserved.
** Released under the GPL Version 2 License.
** http://www.digitalgenesis.com
*/

static const char rcsid[] = "$Id: daemon.cxx,v 1.13 2006/01/24 07:08:09 sella Exp $";

#include "daemon.h"
#include "topology.h"
#include <signal.h>

void sighandler(int sig) {
	switch (sig) {
		case SIGUSR1:
			LMSG("Caught SIGUSR1 - daemon");
			break;

		case SIGUSR2:
			LMSG("Caught SIGUSR2 - daemon");
			break;

		default:
			LMSG("Caught unknown signal - daemon");
	}
}

bool start() {
	Topology *topology = NULL;

	/* Install Signal Handlers */
	if (signal(SIGUSR1, &sighandler) == SIG_ERR) {
		LMSG("Failed to install signal handler for SIGUSR1.");
	}
	if (signal(SIGUSR2, &sighandler) == SIG_ERR) {
		LMSG("Failed to install signal handler for SIGUSR2.");
	}

	if ((topology = new Topology()) != NULL) {
		if (topology->readConfig() == SUCCESS) {
			topology->execute();
		}

		SAFE_DELETE(topology);
	} else {
		LMSG("Failed to allocate memory for Topology().");

		return false;
	}

	return true;
}

const char* getName() {
	return "dsc.topologyd";
}

const char* getDefaultConfigPath() {
	return "discovery topology";
}

const char* getProcTitle() {
	return getName();
}

const char* getDefaultConfigFile() {
	return DEFAULT_CONFIG_FILE;
}

const char* getDefaultPidFile() {
	return DEFAULT_PID_FILE;
}

const char* getDefaultStatFile() {
	return DEFAULT_STAT_FILE;
}

int getDefaultNiceness() {
	return DEFAULT_NICENESS;
}

/*
** Local Variables:
** c-basic-offset: 3
** tab-width: 3
** End:
** vim:
** vim: noet ts=3 sw=3
*/
